from multiprocessing import *
import time

def sumnums(T):
    start = T[0]
    end = T[1]
    total = 0
    for i in range(start, end):
        total = total+ i
    return total

n=10000000

start = time.clock()
total = sumnums((0,n))
end = time.clock()
print("regular sum", total, end-start)

start = time.clock()
pool = Pool(processes=4)
results = pool.map(sumnums, [(0,n//4),(n//4,n//2),(n//2,3*n//4),(3*n//4,n)])

total = 0
for i in range(len(results)):
    total = total + results[i]
end = time.clock()
    
print("multiple processes", total,end-start)

start = 0
end = n//100
L = [(start, end)]
for i in range(99):
    start = start + n//100
    end = end + n//100
    L = L + [(start,end)]
    

start = time.clock()
pool = Pool(processes=100)
results = pool.map(sumnums, L)

total = 0
for i in range(len(results)):
    total = total + results[i]
end = time.clock()
    
print("HUNDRED processes", total,end-start)


